// Definition of the CSocket class

//#ifndef CSocket_class
//#define CSocket_class


#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <unistd.h>
#include <string>
#include <arpa/inet.h>


const int MAXHOSTNAME = 200;
const int MAXCONNECTIONS = 5;
const int MAXRECV = 64;

class CSocket
{
 public:
  CSocket();
  virtual ~CSocket();

  // Server initialization
  bool create();
  void Close();
  bool bind ( const int port );
  bool listen() const;
  bool accept ( CSocket& ) const;

  // Client initialization
  bool connect ( const std::string host, const int port );

  // Data Transimission
  bool send ( const std::string ) const;
  int recv ( std::string&, unsigned int MaxReceive = MAXRECV ) const;


  void set_non_blocking ( const bool );

  bool is_valid() const { return m_sock != -1; }

 private:

  int m_sock;
  sockaddr_in m_addr;


};


//#endif
